from sqlalchemy import Column, Integer, String, DateTime
from .schema import Base


class Proxy(Base):
    __tablename__ = 'proxies'

    id = Column(Integer, primary_key=True)
    host = Column(String, nullable=False)
    port = Column(Integer, nullable=False)
    asn = Column(String)
    egress_ip = Column(String)
    egress_asn = Column(String)
    date_added = Column(DateTime, nullable=False)
    date_validated = Column(DateTime)

    def __repr__(self):
        return (
            f'Proxy(id={self.id}, host={self.host}, port={self.port}, '
            f'egress_ip={self.egress_ip}, date_added={self.created_at})'
        )
