from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker


class SessionFactory:
    def __init__(self, engine_url):
        self.engine = create_engine(engine_url)
        self.Session = sessionmaker(bind=self.engine)

    def create_session(self):
        return self.Session()


# Create a singleton instance of the SessionFactory
session_factory = None


def get_session_factory(engine_url):
    global session_factory
    if session_factory is None:
        session_factory = SessionFactory(engine_url)
    return session_factory


def get_session(engine_url):
    return get_session_factory(engine_url).create_session()
